# Copyright INRA (Institut National de la Recherche Agronomique)
# http://www.inra.fr
# http://urgi.versailles.inra.fr
#
# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use, 
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info". 
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability. 
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or 
# data to be ensured and,  more generally, to use and operate it in the 
# same conditions as regards security. 
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.

from commons.core.sql.DbMySql import DbMySql
from commons.core.utils.RepetOptionParser import RepetOptionParser

def main():
    description = "Check MySQL connection on a node"
    usage = "MysqlConnect.py -n hostname"
           
    parser = RepetOptionParser(description = description, usage = usage, version = "v1.0")
    parser.add_option( "-n", "--node", dest = "node", type = "string", help = "node name", default = "")
    parser.add_option( "-C", "--config", dest = "config", type = "string", help = "path to config file", default = "")
    
    options, args = parser.parse_args()
    
    node = options.node
    
    try:
        if options.config != "":
            idbMySQL = DbMySql(cfgFileName = options.config)
        else:
            idbMySQL = DbMySql()
        print "SUCCESS to connect to MySQL database from '%s'" % node
    except SystemExit:
        print "FAILED to connect to MySQL database from '%s'" % node
    
if __name__ == '__main__':
    main()